attribute vec3 position;
attribute vec4 inputTextureCoordinate;
varying vec2 vTextureCoord;
uniform float texelWidthOffset;
uniform float texelHeightOffset;
varying vec2 blurCoordinates[9];

void main() {
    gl_Position = vec4(position, 1);
    vTextureCoord = inputTextureCoordinate.xy;
    int multiplier;
    vec2 blurStep;
    vec2 singleStepOffset = vec2(texelWidthOffset, texelHeightOffset);
    for (int i = 0; i < 9; i++) {
        multiplier =i-4; //(i - ((9 - 1) / 2));
        blurStep = float(multiplier) * singleStepOffset;
        blurCoordinates[i] = vTextureCoord.xy + blurStep;
    }
}