precision highp float;
uniform sampler2D sTexture;
varying vec2 vTextureCoord;
varying vec2 blurCoordinates[5];
uniform float distanceNormalizationFactor;

void main() {
    vec4 centralColor;
    float gaussianWeightTotal;
    vec4 sum; vec4 sampleColor;
    float distanceFromCentralColor;
    float gaussianWeight;
    centralColor = texture2D(sTexture, blurCoordinates[2]);
    gaussianWeightTotal = 0.18;
    sum = centralColor * 0.18;
    sampleColor = texture2D(sTexture, blurCoordinates[0]);
    distanceFromCentralColor = min(distance(centralColor, sampleColor) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.12 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampleColor * gaussianWeight;
    sampleColor = texture2D(sTexture, blurCoordinates[1]);
    distanceFromCentralColor = min(distance(centralColor, sampleColor) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.15 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampleColor * gaussianWeight;
    sampleColor = texture2D(sTexture, blurCoordinates[3]);
    distanceFromCentralColor = min(distance(centralColor, sampleColor) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.15 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampleColor * gaussianWeight;
    sampleColor = texture2D(sTexture, blurCoordinates[4]);
    distanceFromCentralColor = min(distance(centralColor, sampleColor) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.15 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampleColor * gaussianWeight;
    if (gaussianWeightTotal < 0.4) {
        gl_FragColor = centralColor;
    } else if (gaussianWeightTotal < 0.5) {
        gl_FragColor = mix(sum / gaussianWeightTotal, centralColor, (gaussianWeightTotal - 0.4) / 0.1);
    } else {
        gl_FragColor = sum / gaussianWeightTotal;
    }
}