attribute vec3 aVertexCo;
attribute vec4 aTextureCo;
varying vec2 vTextureCoord;
uniform float texelWidthOffset;
uniform float texelHeightOffset;
varying vec2 blurCoordinates[5];

void main() {
    gl_Position = vec4(aVertexCo, 1);
    vTextureCoord = aTextureCo.xy;
    int multiplier;
    vec2 blurStep;
    vec2 singleStepOffset = vec2(texelWidthOffset, texelHeightOffset);
    for (int i = 0; i < 5; i++) {
        multiplier = i - 2;
        blurStep = float(multiplier) * singleStepOffset;
        blurCoordinates[i] = vTextureCoord.xy + blurStep;
    }
}